'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

let main = (() => {
  var _ref3 = _asyncToGenerator(function* (name, configuration, target) {
    let pp = process.platform;
    let output_directory = target ? _path2.default.resolve('native', 'target', target, configuration) : _path2.default.resolve('native', 'target', configuration);
    let dylib = _path2.default.resolve(output_directory, LIB_PREFIX[pp] + name + LIB_SUFFIX[pp]);
    let index = _path2.default.resolve('native', 'index.node');

    console.log(style.info("generating native" + _path2.default.sep + "index.node"));

    yield (0, _fs.remove)(index);
    yield (0, _fs.copy)(dylib, index);
  });

  return function main(_x, _x2, _x3) {
    return _ref3.apply(this, arguments);
  };
})();

var _fs = require('../async/fs');

var _child_process = require('../async/child_process');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _handlebars = require('handlebars');

var _handlebars2 = _interopRequireDefault(_handlebars);

var _style = require('./style');

var style = _interopRequireWildcard(_style);

var _fsExtra = require('fs-extra');

var _toml = require('toml');

var _toml2 = _interopRequireDefault(_toml);

var _shallowCopy = require('shallow-copy');

var _shallowCopy2 = _interopRequireDefault(_shallowCopy);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const TEMPLATES_DIR = _path2.default.resolve(__dirname, '..', 'templates');

const LIB_PREFIX = {
  'darwin': "lib",
  'freebsd': "lib",
  'linux': "lib",
  'sunos': "lib",
  'win32': ""
};

const LIB_SUFFIX = {
  'darwin': ".dylib",
  'freebsd': ".so",
  'linux': ".so",
  'sunos': ".so",
  'win32': ".dll"
};

function explicit_cargo_target() {
  if (process.platform === 'win32') {
    let arch = process.env.npm_config_arch || process.arch;
    if (arch === 'ia32') {
      return 'i686-pc-windows-msvc';
    } else {
      return 'x86_64-pc-windows-msvc';
    }
  }
}

function cargo(toolchain, configuration, nodeModuleVersion, target) {
  let macos = process.platform === 'darwin';

  var _ref = toolchain === 'default' ? ["cargo", []] : ["multirust", ["run", toolchain]],
      _ref2 = _slicedToArray(_ref, 2);

  let command = _ref2[0],
      prefix = _ref2[1];


  let args = prefix.concat(macos ? 'rustc' : 'build', configuration === 'release' ? ["--release"] : [], macos ? ["--", "-C", "link-args=-Wl,-undefined,dynamic_lookup"] : []);

  // Pass the Node modules ABI version to the build as an environment variable.
  let env = (0, _shallowCopy2.default)(process.env);
  env.NEON_NODE_ABI = nodeModuleVersion || process.versions.modules;

  if (target) {
    args.push("--target=" + target);
  }

  console.log(style.info([command].concat(args).join(" ")));

  return (0, _child_process.spawn)(command, args, { cwd: 'native', stdio: 'inherit', env: env });
}

exports.default = (() => {
  var _ref4 = _asyncToGenerator(function* (pwd, toolchain, configuration, nodeModuleVersion) {
    // 1. Read the Cargo metadata.
    let metadata = _toml2.default.parse((yield (0, _fs.readFile)(_path2.default.resolve('native', 'Cargo.toml'), 'utf8')));

    if (!metadata.lib.name) {
      throw new Error("Cargo.toml does not contain a [lib] section with a 'name' field");
    }

    let target = explicit_cargo_target();

    console.log(style.info("running cargo"));

    // 2. Build the binary.
    if ((yield cargo(toolchain, configuration, nodeModuleVersion, target)) !== 0) {
      throw new Error("cargo build failed");
    }

    // 3. Copy the dylib into the main index.node file.
    yield main(metadata.lib.name, configuration, target);
  });

  function neon_build(_x4, _x5, _x6, _x7) {
    return _ref4.apply(this, arguments);
  }

  return neon_build;
})();